# Copyright 2015, 2017, 2018 Paul Hänsch
#
# This file is part of Confetti.
# 
# Confetti is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Confetti is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with Confetti.  If not, see <http://www.gnu.org/licenses/>. 

cat_listing(){
  list_categories | while read cat; do
    printf '<li>%s<button type="submit" name="remove" value="%s">%s</button></li>\n' \
           "$(htmlsafe "$cat")" "$(attribsafe "$cat")" "$(l10n cat_remove)"
  done
}

list_catsel(){
  card="$1"
  cats="$(get_categories "$card")"

  list_categories |while read cat; do
    printf '<li><label><input %s type="checkbox" name="%s" value="%s">%s</label></li>' \
	   "$(printf %s "$cats" |grep -qF "$cat" && printf 'checked="checked"')" \
           "$(attribsafe "$card")" "$(attribsafe "$cat")" "$(htmlsafe "$cat")" 
  done
}

display_catsel(){
  card="$1"
  printf '<li><h2>%s</h2><ul>' "$(htmlsafe "$(get_name "$card")")"
  list_catsel "$card"
  printf '</ul></li>'
}

cat <<EOF
<form class="categories" action="?action=edit_categories" method="POST">
  <input type="submit" class="fakeorder" name="add" value="add" />
  <h1>$(l10n categories_label)</h1>
  <input type="hidden" name="page" value="categories"/>
  <ul>
    $(cat_listing)
    <li>
      <input type="text" name="newcat" placeholder="$(l10n cat_newlabel)">
      <button type="submit" name="add" value="add">$(l10n cat_add)</button>
    </li>
  </ul>
</form>

<form class="namelist" action="?action=update_categories" method="POST">
  <fieldset>
    <button type="submit" name="submit" value="submit">$(l10n cat_update)</button>
  </fieldset>
  <ul class="namelist">
EOF
listcards \
| while read card; do
  display_catsel "$card"
done
cat <<EOF
  </ul>
  <fieldset>
    <button type="submit" name="submit" value="submit">$(l10n cat_update)</button>
  </fieldset>
</form>
EOF

